/**
 * Created by pawanpawar on 1/6/17.
 */
'use strict';

var fs = require('fs');
var console = new (require('my-console')).Console();

var DEFAULTS = {
    command: 'arp-scan',
    args: ['-l'],
    interface: 'wlan0',
    listByInterface: false,
    sudo: false
};

var scan = function (cb, options) {
    var out = [];
    fs.readFile('/proc/net/arp', function (err, data) {
        if (err) {
            console.error(err);
            cb(err, null);
        } else {
            data = data.toString().trim().split('\n');
            data.splice(0, 1);
            data.forEach(function (line) {
                const chunks = line.trim().replace(/\s\s+/g, ' ').split(' ');
                if (chunks[3].toString() != '00:00:00:00:00:00') {
                    out.push({
                        ip: chunks[0],
                        mac: chunks[3].toString().toUpperCase(),
                        interface: chunks[5],
                        timestamp: Date.now()
                    });
                }
            });
            cb(null, out);
        }
    });
};

module.exports = scan;
